package exnihilocreatio.tiles;

import exnihilocreatio.rotationalPower.CapabilityRotationalMember;
import exnihilocreatio.rotationalPower.IRotationalPowerMember;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ITickable;
import net.minecraftforge.common.capabilities.Capability;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class TileStoneAxle extends BaseTileEntity implements ITickable, IRotationalPowerMember {
    public float rotationValue = 0;
    public float perTickEffective = 0F;

    public EnumFacing facing = EnumFacing.NORTH;

    private int counter = -1;

    @Override
    public void func_73660_a() {
        counter++;

        if (counter > 0 && counter % 10 == 0) {
            float lastPerTickEffective = perTickEffective;
            perTickEffective = calcEffectivePerTickRotation(field_145850_b, field_174879_c, facing);

            if (lastPerTickEffective != perTickEffective) {
                func_70296_d();
            }
            counter = 0;
        }

        if (field_145850_b.field_72995_K) {
            rotationValue += perTickEffective;
        }
    }


    @Override
    @Nonnull
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        if (facing != null)
            tag.func_74778_a("facing", facing.func_176610_l());
        tag.func_74776_a("rot", rotationValue);

        return super.func_189515_b(tag);
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        if (tag.func_74764_b("facing"))
            facing = EnumFacing.func_176739_a(tag.func_74779_i("facing"));
        if (tag.func_74764_b("rot"))
            rotationValue = tag.func_74760_g("rot");
    }

    @Override
    public float getOwnRotation() {
        return 0;
    }

    @Override
    public float getEffectivePerTickRotation(EnumFacing direction) {
        if (facing == direction) {
            return perTickEffective;
        } else {
            return 0;
        }
    }

    @Override
    public boolean hasCapability(Capability<?> capability, @Nullable EnumFacing facing) {
        return capability == CapabilityRotationalMember.ROTIONAL_MEMBER && facing == this.facing || super.hasCapability(capability, facing);
    }

    @Nullable
    @Override
    public <T> T getCapability(Capability<T> capability, @Nullable EnumFacing facing) {
        if (capability == CapabilityRotationalMember.ROTIONAL_MEMBER && facing == this.facing)
            return CapabilityRotationalMember.ROTIONAL_MEMBER.cast(this);
        return super.getCapability(capability, facing);
    }

    @Override
    public void setEffectivePerTickRotation(float rotation) {
        perTickEffective = rotation;
    }
}
